--[[-- Copyright (c) 2024 Huawei Technologies Co., Ltd.
-- openUBMC is licensed under Mulan PSL v2.
-- You can use this software according to the terms and conditions of the Mulan PSL v2.
-- You may obtain a copy of Mulan PSL v2 at:
--          http://license.coscl.org.cn/MulanPSL2
-- THIS SOFTWARE IS PROVIDED ON AN "AS IS" BASIS, WITHOUT WARRANTIES OF ANY KIND,
-- EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO NON-INFRINGEMENT,
-- MERCHANTABILITY OR FIT FOR A PARTICULAR PURPOSE.
-- See the Mulan PSL v2 for more details.
]] --
local validate = require 'mc.validate'
local utils = require 'mc.utils'

local SetControllerOutofband = {}

---@class StorageIpmiCmds.SetControllerOutofbandReq
---@field ManufacturerId integer
---@field Reserve integer
---@field ControllerId integer
---@field Frame integer
---@field WritingOffset integer
---@field WritingLength integer
---@field Data string
local TSetControllerOutofbandReq = {}
TSetControllerOutofbandReq.__index = TSetControllerOutofbandReq
TSetControllerOutofbandReq.group = {}

local function TSetControllerOutofbandReq_from_obj(obj)
    return setmetatable(obj, TSetControllerOutofbandReq)
end

function TSetControllerOutofbandReq.new(ManufacturerId, Reserve, ControllerId, Frame, WritingOffset, WritingLength, Data)
    return TSetControllerOutofbandReq_from_obj({
        ManufacturerId = ManufacturerId,
        Reserve = Reserve,
        ControllerId = ControllerId,
        Frame = Frame,
        WritingOffset = WritingOffset,
        WritingLength = WritingLength,
        Data = Data
    })
end
---@param obj StorageIpmiCmds.SetControllerOutofbandReq
function TSetControllerOutofbandReq:init_from_obj(obj)
    self.ManufacturerId = obj.ManufacturerId
    self.Reserve = obj.Reserve
    self.ControllerId = obj.ControllerId
    self.Frame = obj.Frame
    self.WritingOffset = obj.WritingOffset
    self.WritingLength = obj.WritingLength
    self.Data = obj.Data
end

function TSetControllerOutofbandReq:remove_error_props(errs, obj)
    utils.remove_obj_error_property(obj, errs, TSetControllerOutofbandReq.group)
end

TSetControllerOutofbandReq.from_obj = TSetControllerOutofbandReq_from_obj

TSetControllerOutofbandReq.proto_property = {
    'ManufacturerId', 'Reserve', 'ControllerId', 'Frame', 'WritingOffset', 'WritingLength', 'Data'
}

TSetControllerOutofbandReq.default = {0, 0, 0, 0, 0, 0, ''}

TSetControllerOutofbandReq.struct = {
    {name = 'ManufacturerId', is_array = false, struct = nil}, {name = 'Reserve', is_array = false, struct = nil},
    {name = 'ControllerId', is_array = false, struct = nil}, {name = 'Frame', is_array = false, struct = nil},
    {name = 'WritingOffset', is_array = false, struct = nil}, {name = 'WritingLength', is_array = false, struct = nil},
    {name = 'Data', is_array = false, struct = nil}
}

function TSetControllerOutofbandReq:validate(prefix, errs, need_convert)
    prefix = prefix or ''

    validate.Optional(prefix .. 'ManufacturerId', self.ManufacturerId, 'uint32', false, errs, need_convert)
    validate.Optional(prefix .. 'Reserve', self.Reserve, 'uint8', false, errs, need_convert)
    validate.Optional(prefix .. 'ControllerId', self.ControllerId, 'uint8', false, errs, need_convert)
    validate.Optional(prefix .. 'Frame', self.Frame, 'uint8', false, errs, need_convert)
    validate.Optional(prefix .. 'WritingOffset', self.WritingOffset, 'uint16', false, errs, need_convert)
    validate.Optional(prefix .. 'WritingLength', self.WritingLength, 'uint8', false, errs, need_convert)
    validate.Optional(prefix .. 'Data', self.Data, 'string', false, errs, need_convert)

    TSetControllerOutofbandReq:remove_error_props(errs, self)
    validate.CheckUnknowProperty(self, TSetControllerOutofbandReq.proto_property, errs, need_convert)
    return self
end

function TSetControllerOutofbandReq:unpack(_)
    return self.ManufacturerId, self.Reserve, self.ControllerId, self.Frame, self.WritingOffset, self.WritingLength,
        self.Data
end

SetControllerOutofband.SetControllerOutofbandReq = TSetControllerOutofbandReq

---@class StorageIpmiCmds.SetControllerOutofbandRsp
---@field CompletionCode integer
---@field ManufactureId integer
---@field Reserve integer
---@field Data string
local TSetControllerOutofbandRsp = {}
TSetControllerOutofbandRsp.__index = TSetControllerOutofbandRsp
TSetControllerOutofbandRsp.group = {}

local function TSetControllerOutofbandRsp_from_obj(obj)
    return setmetatable(obj, TSetControllerOutofbandRsp)
end

function TSetControllerOutofbandRsp.new(CompletionCode, ManufactureId, Reserve, Data)
    return TSetControllerOutofbandRsp_from_obj({
        CompletionCode = CompletionCode,
        ManufactureId = ManufactureId,
        Reserve = Reserve,
        Data = Data
    })
end
---@param obj StorageIpmiCmds.SetControllerOutofbandRsp
function TSetControllerOutofbandRsp:init_from_obj(obj)
    self.CompletionCode = obj.CompletionCode
    self.ManufactureId = obj.ManufactureId
    self.Reserve = obj.Reserve
    self.Data = obj.Data
end

function TSetControllerOutofbandRsp:remove_error_props(errs, obj)
    utils.remove_obj_error_property(obj, errs, TSetControllerOutofbandRsp.group)
end

TSetControllerOutofbandRsp.from_obj = TSetControllerOutofbandRsp_from_obj

TSetControllerOutofbandRsp.proto_property = {'CompletionCode', 'ManufactureId', 'Reserve', 'Data'}

TSetControllerOutofbandRsp.default = {0, 0, 0, ''}

TSetControllerOutofbandRsp.struct = {
    {name = 'CompletionCode', is_array = false, struct = nil}, {name = 'ManufactureId', is_array = false, struct = nil},
    {name = 'Reserve', is_array = false, struct = nil}, {name = 'Data', is_array = false, struct = nil}
}

function TSetControllerOutofbandRsp:validate(prefix, errs, need_convert)
    prefix = prefix or ''

    validate.Optional(prefix .. 'CompletionCode', self.CompletionCode, 'uint8', false, errs, need_convert)
    validate.Optional(prefix .. 'ManufactureId', self.ManufactureId, 'uint32', false, errs, need_convert)
    validate.Optional(prefix .. 'Reserve', self.Reserve, 'uint32', false, errs, need_convert)
    validate.Optional(prefix .. 'Data', self.Data, 'string', false, errs, need_convert)

    TSetControllerOutofbandRsp:remove_error_props(errs, self)
    validate.CheckUnknowProperty(self, TSetControllerOutofbandRsp.proto_property, errs, need_convert)
    return self
end

function TSetControllerOutofbandRsp:unpack(_)
    return self.CompletionCode, self.ManufactureId, self.Reserve, self.Data
end

SetControllerOutofband.SetControllerOutofbandRsp = TSetControllerOutofbandRsp

return SetControllerOutofband
